/*
 * @(#) XDCC IRC	0.1	17/02/2002
 *
 * Copyright (c), 2002
 *
 * iniLoader, to load/write client ini file.
 *
 *
 */

import java.util.Properties;
import java.io.*;
import java.lang.reflect.*;

public class IniLoader {
	private String property; 			// Nom de la property
	private String[] servers = new String[50];
	private String[] nicks = new String[3];
	private String[] channels = new String[50];
	private String options = "";
	private int nbProperty;				// Nombre de property
	private FileInputStream fis;	
	private Properties p;
	private FileOutputStream fos;
	private PrintStream ps;

  IniLoader() {
	this.property = "server1";
	this.nbProperty = 1;

	if (!iniCreated()) {
		createIni();
	}

	try {
		fis = new FileInputStream("Xdcc.ini");	
		p = new Properties();

		try {
			p.load(fis);
			fis.close();
		}
		catch(IOException e1) {
			System.out.println("Some IOException, please try again!!! " + e1);
		}		


	}
	catch(FileNotFoundException e1) {
		System.out.println("File Not Found, please try again!!! " + e1);
	}
  }

  public boolean iniCreated() {
	try {
		fis = new FileInputStream("Xdcc.ini");		
	}
	
	catch(FileNotFoundException e1) {
		return false;
	}
	return true;
  }

  public String[] getServers() {
	for (int i = 0; i < 50; i++) {
		property = "server" + Integer.toString(i);
		servers[i] = p.getProperty(property);
	}
	return servers;
  }

  public void setServers(Object[] serverList) {
  	int arrayLength = Array.getLength(serverList);
  	try {
  		fos = new FileOutputStream("Xdcc.ini");
	}
	catch (FileNotFoundException e) {
		System.out.println("File Xdcc.ini not found! have you deleted it ? restart the program!");
	}
	for (int i = 0; i < arrayLength; i++) {
		servers[i] = (String)serverList[i];
		property = "server" + Integer.toString(i);
		p.setProperty(property, servers[i]);
	}
	for (int i = arrayLength; i < 50; i++) {
		servers[i] = "";
		property = "server" + Integer.toString(i);
		p.setProperty(property, servers[i]);
	}
	try {
		p.store(fos, "Connection Info Stuff");
		fos.close();
	}
	catch (IOException e) {
		System.out.println("Some bad IOException -> " + e);
	}
  }

  public String[] getNicks() {
	nicks[0] = p.getProperty("nick0");
	nicks[1] = p.getProperty("nick1");
	nicks[2] = p.getProperty("nick2");
	return nicks;
  }

  public void setNicks(String[] nickList) {
  	try {
  		fos = new FileOutputStream("Xdcc.ini");
	}
	catch (FileNotFoundException e) {
		System.out.println("File Xdcc.ini not found! have you deleted it ? restart the program!");
	}
	for (int i = 0; i < 3; i++) {
		nicks[i] = nickList[i];
		property = "nick" + Integer.toString(i);
		p.setProperty(property, nicks[i]);
	}
	try {
		p.store(fos, "No Comments");
		fos.close();
	}
	catch (IOException e) {
		System.out.println("Some bad IOException -> " + e);
	}
  }

  public String[] getChannels() {
	for (int i = 0; i < 50; i++) {
		property = "channel" + Integer.toString(i);
		channels[i] = p.getProperty(property);
	}
	return channels;
  }

  public void setChannels(Object[] channelList) {
  	int arrayLength = Array.getLength(channelList);
  	try {
  		fos = new FileOutputStream("Xdcc.ini");
	}
	catch (FileNotFoundException e) {
		System.out.println("File Xdcc.ini not found! have you deleted it ? restart the program!");
	}
	for (int i = 0; i < arrayLength; i++) {
		channels[i] = (String)channelList[i];
		property = "channel" + Integer.toString(i);
		p.setProperty(property, channels[i]);
	}
	for (int i = arrayLength; i < 50; i++) {
		channels[i] = "";
		property = "channel" + Integer.toString(i);
		p.setProperty(property, channels[i]);
	}
	try {
		p.store(fos, "No Comments");
		fos.close();
	}
	catch (IOException e) {
		System.out.println("Some bad IOException -> " + e);
	}
  }

  public String getOptions() {
	options = p.getProperty("options");
	return options;
  }
  
  public void setOptions(String option, int beginPos, int endPos) {
  	char[] optionsChar = new char[50];     // to hold current options
  	options = p.getProperty("options");  // loading current options
  	optionsChar = options.toCharArray(); // 
  	for (int i = 0; i < endPos - beginPos; i++) {
  		optionsChar[beginPos + i] = option.charAt(i); // set new options
  	}
  	options = new String(optionsChar);
  	p.setProperty("options", options);
  }
  	

  public boolean createIni() {
	try {
		fos = new FileOutputStream("Xdcc.ini");
		PrintStream ps = new PrintStream( fos );
		for (int i = 0; i < 49; i++) {
			ps.println("server" + i + "=");
		}
		for (int i = 0; i < 49; i++) {
			ps.println("channel" + i + "=");
		}
		for (int i = 0; i < 2; i++) {
			ps.println("nick" + i + "=");
		}
		ps.println("options" + "=100000000");
/*        	ps.println("server1 = irc2.magic.ca");	
        	ps.println("server2 = irc.prison.net");
        	ps.println("channel0 = #0DayVCD");
        	ps.println("channel1 = #imp-iso");
        	ps.println("channel2 = #albums");
        	ps.println("channel3 = #isoparadise");
        	ps.println("nick0 = XDCC5673`");
        	ps.println("nick1 = XDCC7366`");
        	ps.println("nick2 = XDCC8347`");*/
        	
		
//        	p.store(fos, "Connection Info Stuff");
		ps.close();
        	fos.close();
		return true;			
	}
	catch(IOException e1) {
		System.out.println("Some bad IOException");
		return false;
	}
  }
}

//[15:41] @calchas the current fashion (with some merit) is the use XML files
//[15:42] @calchas and the XML parsers to read and write it
/*  Options description
0 = autoreconnect
1 = perform
2 = log privates
3 = log channels
4 = flood prot
5 = strip control codes
6 = timestamp events
7 = auto-accept dcc sends
8 = auto-resume
9-12 = timeout (secs)
13-17 = packet size
*/