/*
 * @(#) XDCC IRC	0.1	17/02/2002
 *
 * Copyright (c), 2002
 *
 * This program is used to get more easily XDCC Packs on IRC.
 * parseSendToCommand("command to send");
 *
 */

import java.util.Collections; 
import java.util.Arrays;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.Timer;

import java.io.*;
import java.net.*;

import java.text.*;

import java.util.*;



public class XdccIrc extends JFrame implements Runnable { //, WindowListener
	String host = "irc.prison.net";
	int port = 6667;
	String whatOS = "";
	JTabbedPane tabbedPane;
	//XdccTree xdccTree;
	// 5 = # of DCC arguments and 128 = max number of DCCs
	String[][] xdccInfos = new String[128][5];
	//0 = port
	//1 = address
	//2 = Filename
	//3 = File Size
	//4 = Resume Position
	int numDcc = 0;

	String nickname;
	String realname;
//iniloader stuff
	final IniLoader iniLoader = new IniLoader();
	String[] nicknames = new String[3];
	String[] servers = new String[50];
	String[] channels = new String[50];
	String options = "";
        // Menu bar and menu items
	private JMenuBar menuBar = new JMenuBar();
	private JMenuItem newChannelPanelItem,
	                  newUserPanelItem;

	private Action newChannelAction, newUserAction;

	// Action to join a Channel
	private Action changeNickAction;
	private Action whoisAction;
	private Action aboutAction;
	private Action disconnectAction;
	private Action channelListAction;

	private JDialog dialog;
	JTextField nickJTextField1;
	JTextField nickJTextField2;
	JTextField nickJTextField3;

	String nickname1, nickname2, nickname3;

	// List to hold server list
	JList serverList;
	DefaultListModel serverListModel;
	
	// For communicating purposes. You write to 'toServer' to
	// send something to the IRC server. For example:
	//       toServer.print("A dummy message")
	// should send a message to IRC server
	// 'fromServer' reads something from the IRC server.
	private Socket chatSocket;
	BufferedReader fromServer;
	PrintWriter toServer;
//	BufferedWriter toServer;

	/**
	 * Main Constructor. Here,
	 *   host: the IRC hostname. Should be a valid hostname
	 *   port: the port where IRC server is listening
	 *         generally this is port 6667
	 */
	public XdccIrc(String host, int port) {
		this.host = host;
		this.port = port;

		this.whatOS = System.getProperty("os.name") + " (" + System.getProperty("os.arch") + ") (" + System.getProperty("os.version") + ")";
		System.out.println(whatOS);
                // set's the title of the XDCC IRC window
		setTitle("XDCC IRC");

		setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		addWindowListener(new WindowCloser());

		// set default icon image for all windows....
		setIconImage( Toolkit.getDefaultToolkit().getImage("images/satelite16x16.gif") );
		setJMenuBar(menuBar);

		JMenu connectionMenu = new JMenu("Connection");
		connectionMenu.setMnemonic('C');

		JMenuItem connectionMenuItem = new JMenuItem("New Connection...");
		JMenuItem optionsMenuItem = new JMenuItem("Options...");
		connectionMenu.add(connectionMenuItem);
		connectionMenu.add(optionsMenuItem);
		
		connectionMenuItem.addActionListener(new ActionListener() {
		      public void actionPerformed(ActionEvent e) {
		         makeConnectionPanel();
		      }
		   });

		optionsMenuItem.addActionListener(new ActionListener() {
		      public void actionPerformed(ActionEvent e) {
		         createOptionsDialog();
		      }
		   });

		JMenu actionMenu = new JMenu("Actions");
		actionMenu.setMnemonic('A');

		JMenu helpMenu = new JMenu("Help");
		helpMenu.setMnemonic('H');
		
		channelListAction = new ChannelListAction("Channels..", KeyStroke.getKeyStroke('L', Event.CTRL_MASK));
		newUserAction = new NewUserAction("Private msg..", KeyStroke.getKeyStroke('P', Event.CTRL_MASK));
                changeNickAction = new ChangeNickAction("Change nick..", KeyStroke.getKeyStroke('N', Event.CTRL_MASK));
                whoisAction = new WhoisAction("Whois..", KeyStroke.getKeyStroke('W', Event.CTRL_MASK));
                aboutAction = new AboutAction("About XDCC IRC");
                disconnectAction = new DisconnectAction("Disconnect", KeyStroke.getKeyStroke('D', Event.CTRL_MASK));

		addMenuItem(actionMenu, newUserAction);
		addMenuItem(actionMenu, channelListAction);
		addMenuItem(actionMenu, changeNickAction);
		addMenuItem(actionMenu, whoisAction);
		addMenuItem(actionMenu, disconnectAction);
		addMenuItem(helpMenu, aboutAction);
		
		tabbedPane = createTabbedPane();

		
//		newUserAction = new NewUserAction("Talk Private", new ImageIcon("Boxopened.gif"));
                // Let's create a ToolBar
		JToolBar toolBar = new JToolBar();
		toolBar.add(disconnectAction);
		toolBar.add(channelListAction);
		toolBar.add(newUserAction);
		toolBar.add(changeNickAction);
		toolBar.add(whoisAction);

		toolBar.setBorder(BorderFactory.createCompoundBorder(
                                  BorderFactory.createRaisedBevelBorder(),
                                  BorderFactory.createEmptyBorder(5,5,5,5)));
		
		getContentPane().add("North", toolBar);
		getContentPane().add("Center", tabbedPane);
		
		// Menus
		menuBar.add(actionMenu);
		menuBar.add(connectionMenu);
		menuBar.add(helpMenu);
		
                // mandatory things to do!
		//setBounds(50, 50, 600, 400);
                Toolkit theKit = java.awt.Toolkit.getDefaultToolkit();
		Dimension dm = theKit.getScreenSize();

		setBounds(0, 0,
			  (dm.width), // width
		          (dm.height - 25) // height
		         );

		//setDefaultCloseOperation(EXIT_ON_CLOSE);
		setVisible(true);

		// Let's see How can get connection info
		makeConnectionPanel();
	}

	class WindowCloser extends WindowAdapter {
  		public void windowClosing(WindowEvent e) {
    			Window win = e.getWindow();
    			if (ReadDccFile.threadNum != 0) {
    				if (showQuestionDialog("Really Exit? DCC Pending..") == 0) {
    					win.setVisible(false);
    					parseSendToCommand("QUIT :Connection Closed.");
    					System.exit(0);
    				}
    			}
    			
    			else if (toServer != null) {
    				win.setVisible(false);
    				parseSendToCommand("QUIT :Connection Closed.");
    				System.exit(0);
    			}
    			else {
    				win.setVisible(false);
    				System.exit(0);
    			}
    		}
	}

	public void createOptionsDialog() {
		MakeOptionsDialog makeOptionsDialog = new MakeOptionsDialog(this);
	}
	
	public int showQuestionDialog(String line) {
		return (JOptionPane.showConfirmDialog(this, line));
	}

	public void connectStartRegister() {
	   connect();
	   start();
	   register();
	}

	private void makeConnectionPanel() {
	   dialog = new JDialog(this, " Connection Info ", true);
           Border etched = BorderFactory.createEtchedBorder();

	   Container dialogContentPane = dialog.getContentPane();

	   // Ok, let's make the UserInfo
	   JPanel userInfo = new JPanel();
	   userInfo.setBorder(makeBorder(" User Info "));
	   JLabel label1 = new JLabel("Nickname1: ");
	   JLabel label2 = new JLabel("Nickname2: ");
	   JLabel label3 = new JLabel("Nickname3: ");

	   nickJTextField1 = new JTextField(25);
	   nickJTextField2 = new JTextField(25);
           nickJTextField3 = new JTextField(25);
           
          final  JCheckBox autoReconnectCB = new JCheckBox("Auto-reconnect?");
           
	   Box box1 = Box.createHorizontalBox();
	   box1.add(label1);
	   box1.add(nickJTextField1);

	   Box box2 = Box.createHorizontalBox();
	   box2.add(label2);
	   box2.add(nickJTextField2);

           Box box3 = Box.createHorizontalBox();
           box3.add(label3);
           box3.add(nickJTextField3);

           Box box4 = Box.createVerticalBox();
           box4.add(box1);
           box4.add(box2);
           box4.add(box3);
	   Random random = new Random();
	   nicknames = iniLoader.getNicks();
	   servers = iniLoader.getServers();
	   //channels = iniLoader.getChannels();
	   options = iniLoader.getOptions();
	   nickJTextField1.setText(nicknames[0]);
	   nickJTextField2.setText(nicknames[1]);
	   nickJTextField3.setText(nicknames[2]);

	   if (options.charAt(0) == '1') {
	   	autoReconnectCB.setSelected(true);
	   }

           userInfo.add("Center", box4);

           // Let's make the Server area
	   JPanel serverInfo = new JPanel();
	   serverInfo.setBorder(makeBorder(" Server Info "));
	   serverListModel = new DefaultListModel();
	   for (int i = 0; !servers[i].equals(""); i++) {
	   	serverListModel.addElement(servers[i]);
	   }	
	   serverList = new JList(serverListModel);
	   Dimension listSize = new Dimension(200,250);
	   serverList.setPreferredSize(listSize);
	   //list.setVisibleRowCount(5);
	   JScrollPane scrollPane = new JScrollPane(serverList);
	   scrollPane.setBorder(BorderFactory.createLoweredBevelBorder());
	   JButton addButton = new JButton("Add");
           JButton editButton = new JButton("Edit");
           JButton removeButton = new JButton("Remove");
           addButton.setBorder(makeButtonBorder());
           editButton.setBorder(makeButtonBorder());
           removeButton.setBorder(makeButtonBorder());
           Box sbox1 = Box.createVerticalBox();
	   sbox1.add(scrollPane);
	   sbox1.add("Bottom", autoReconnectCB);
           Box sbox2 = Box.createVerticalBox();
	   sbox2.add("Top", addButton);
	   sbox2.add("Right", editButton);
	   sbox2.add("Bottom", removeButton);
	   Box sbox3 = Box.createHorizontalBox();
	   sbox3.add(sbox1);
	   sbox3.add(sbox2);
	   serverInfo.add("Center", sbox3);
           JPanel buttonPanel = new JPanel();
           buttonPanel.setBorder(BorderFactory.createCompoundBorder(
	                               BorderFactory.createLineBorder(Color.black, 1),
                                       BorderFactory.createRaisedBevelBorder()
                               ));

           JButton connectButton = new JButton("Connect");
           JButton okButton = new JButton("Ok");
           JButton cancelButton = new JButton("Cancel");

           connectButton.setBorder(makeButtonBorder());
           okButton.setBorder(makeButtonBorder());
           cancelButton.setBorder(makeButtonBorder());

           // Action Listener
           connectButton.addActionListener(new ActionListener() {
	         public void actionPerformed(ActionEvent e) {
		    if (nickJTextField1.getText() != null) {
			setNickname(nickJTextField1.getText());
			nicknames[0] = nickJTextField1.getText();
		    }
		    else {
		    	setNickname(nicknames[0]);
		    }

		    if (nickJTextField2.getText() != null) {
			nickname2 = nickJTextField2.getText();
			nicknames[1] = nickJTextField2.getText();
		    }

		    if (nickJTextField3.getText() != null) {
			nickname3 = nickJTextField3.getText();
			nicknames[2] = nickJTextField3.getText();
		    }
		iniLoader.setNicks(nicknames);
		iniLoader.setServers(serverListModel.toArray());
		if (autoReconnectCB.isSelected()) {
			iniLoader.setOptions("1", 0, 1);
		}
		else {
			iniLoader.setOptions("0", 0, 1);
		}
		    // Setting the hostname(the IRC server)
                    if (serverList.getSelectedValue() != null) {
			host = (String)serverList.getSelectedValue();
			tabUpdate("Init Window", " Connecting to: " + serverList.getSelectedValue());
			System.out.println("Connecting to: " + serverList.getSelectedValue());
			dialog.dispose();
			dialog = null;
			if (toServer != null) {
				closeAll();
				tabUpdate("Init Window", "Disconnected!");
			}
		       connectStartRegister();
		    }
		 }
	      });
           cancelButton.addActionListener(new ActionListener() {
	         public void actionPerformed(ActionEvent e) {
		    dialog.dispose();
		    dialog = null;
		 }
	      });

           okButton.addActionListener(new ActionListener() {
	         public void actionPerformed(ActionEvent e) {
		    if (nickJTextField1.getText() != null) {
			setNickname(nickJTextField1.getText());
			nicknames[0] = nickJTextField1.getText();
		    }
		    else {
		    	setNickname(nicknames[0]);
		    }
		    if (autoReconnectCB.isSelected()) {
			iniLoader.setOptions("1", 0, 1);
		    }
		    else {
			iniLoader.setOptions("0", 0, 1);
		    }
		    if (nickJTextField2.getText() != null) {
			nickname2 = nickJTextField2.getText();
			nicknames[1] = nickJTextField2.getText();
		    }

		    if (nickJTextField3.getText() != null) {
			nickname3 = nickJTextField3.getText();
			nicknames[2] = nickJTextField3.getText();
		    }
		    iniLoader.setNicks(nicknames);
		    iniLoader.setServers(serverListModel.toArray());
		    dialog.dispose();
		    dialog = null;
		 }
	      });

           addButton.addActionListener(new ActionListener() {
	         public void actionPerformed(ActionEvent e) {
	         String serverToAdd = "";
		 serverToAdd = JOptionPane.showInputDialog(" What Server you want to add ? ");
		 if (serverToAdd != null && !serverToAdd.equals("")) {
		 	serverListModel.addElement(serverToAdd);
		 }
		 }
	      });

           editButton.addActionListener(new ActionListener() {
	         public void actionPerformed(ActionEvent e) {
	         String serverToEdit = "";
		 String serverEdited = "";
		 if (serverList.getSelectedValue() != null) {
		 	serverToEdit = (String)serverList.getSelectedValue();
		  	serverEdited = JOptionPane.showInputDialog(" Change this server to: ", serverToEdit);
		  	if (serverEdited != null && !serverEdited.equals("")) {
		  		serverListModel.setElementAt(serverEdited, serverList.getSelectedIndex());
		  	}
		 }
		}
	      });

           removeButton.addActionListener(new ActionListener() {
	         public void actionPerformed(ActionEvent e) {
		 if (serverList.getSelectedIndex() != -1) {
		       serverListModel.removeElementAt(serverList.getSelectedIndex());
		 }			
		 }
	      });
	      
           buttonPanel.add(connectButton);
           buttonPanel.add(okButton);
           buttonPanel.add(cancelButton);

           dialogContentPane.add("North", userInfo);
           dialogContentPane.add("Center", serverInfo);
           dialogContentPane.add("South", buttonPanel);

	   dialog.pack();
	   dialog.setLocationRelativeTo(this);
	   dialog.show();
	}

        private Border makeButtonBorder() {
           return BorderFactory.createCompoundBorder(
                     BorderFactory.createRaisedBevelBorder(),
                     BorderFactory.createEmptyBorder(2,4,2,4)
                     );
        }


        private Border makeBorder(String title) {
           Border etched = BorderFactory.createEtchedBorder();
	   Border border = BorderFactory.createTitledBorder(etched, title, TitledBorder.CENTER, TitledBorder.TOP);
           return border;
	}

        /**
	 * Connect tries to establish a connection to host in port
	 */
	private void connect() {
		try {
			chatSocket = new Socket(host, port);
			fromServer = new BufferedReader(new InputStreamReader(chatSocket.getInputStream()));
                        toServer = new PrintWriter(chatSocket.getOutputStream());
			Component aComponent = tabbedPane.getComponentAt(0);
			((InitPanel)aComponent).setTitleArea(nickname + " connected to: " + host + ":" + port);
		}
		catch(IOException e) {
			System.err.println("Connection refused to: " + host + ":" + port);
		}
	}

	private void register() {

		realname = nickname;

                parseSendToCommand("PASS xdcc6666");
                parseSendToCommand("NICK " + nickname);
                parseSendToCommand("USER " + nickname + " 0 * :" + realname);
	}

        // sends back your current nickname
	public String getNickname() {
	   return nickname;
	}

	// setNickname sets your current nickname
	public void setNickname(String nickname) {
	   this.nickname = nickname;
	}

	public void changeNickname(String oldNickname, String newNickname) {

	   for (int i = 0; i < tabbedPane.getTabCount(); i++) {
	      Component aComponent = tabbedPane.getComponentAt(i);

	      if (aComponent instanceof ChannelPanel) {
		 if (((ChannelPanel)aComponent).usernameList.contains(oldNickname)) {
		 	((ChannelPanel)aComponent).updateUserArea(oldNickname, "remove");
		 	((ChannelPanel)aComponent).updateUserArea(newNickname, "add");
		 	((ChannelPanel)aComponent).updateTextArea(oldNickname + " changes nickname to " + newNickname);
		 }
	      }
	      else if (aComponent instanceof UserPanel) {
	         // Do UserPanel processing
		 // Actually this process was done in the NICK handling part....
	      }
	   }
	}

	public String formatNickname(String nickname) {
	   int formatlen = 12;
	   String blank = "";
	   int len = nickname.length();

	   if (len >= formatlen) {
	      return nickname;
	   }
	   else {
	      for (int i = 0; i < (formatlen - len); i++) {
	         blank = blank + " ";
	      }
	   }

	   return nickname + blank;
	}

	// send back realname. Did I need it really?
	public String getRealname() {
	   return realname;
	}

	private Thread listener;
	// Starting to listen something from the IRC server.
	// Don't forget to take a look at the run() method 
	// --- cause that is where exact job is done.
	public void start() { //synchronized void start()
		listener = new Thread(this);
		listener.setDaemon(true);
		listener.start();
	}
	
	// Starts listening something from the IRC server.
	// As soon as it receives something from the IRC
	// server, it sends the 'received-data' to 'parseFromServer'
	// --- so take a look at 'parseFromServer'. 'parseFromServer'
	// is the most responsible party that does all the necessary
	// processing of 'replies' or IRC server.
	public void run() {
		try {
			while(!Thread.interrupted()) {
				String line = fromServer.readLine();
				if (line != null) {
					parseFromServer(line);
				}
				else {
				   // a null line indicates that our server has
				   // closed the connection, right?
				   for (int i = 0; i < tabbedPane.getTabCount(); i++)
				   {
				   	Component aComponent = tabbedPane.getComponentAt(i);
		   			if (aComponent instanceof ChannelPanel) {
			   			((ChannelPanel)aComponent).updateTextArea("You have been disconnected.. you need to rejoin the channel after connecting.");
		   			}
				   }
				   tabUpdate("Init Window", "You have been disconnected.");
				   closeAll();
				   
				   try {
				      // sleeping for 5 seconds!
				      listener.sleep(5000);
				   }
				   catch(InterruptedException e) {
				   }

				   listener = null;
				   // Check if we want to auto-reconnect
				   options = iniLoader.getOptions();
				   if (options.charAt(0) == '1') {
	   				connectStartRegister();
	   			   }
				}
			}
		}
		
		catch(IOException e) {
		   System.out.println("Read Exception from Server. Exception is something like:");
		   System.out.println(e);
		}
	}

	// Close everything and sleeps for few seconds
	public void closeAll() {
	   // So, let's shutdown everything
	   try {
	      chatSocket.close();
	      fromServer.close();
	      toServer.close();
	   }
	   catch(IOException e) {
	      System.out.println("chatSocket.close() thrown an IOException or");
	      System.out.println("fromServer.close() thrown an IOException or");
	      System.out.println("toServer.close() thrown an IOException");
	   }

	   chatSocket = null;
	   fromServer = null;
	   toServer = null;
	}

        // Well this method is the most responsible party in
	// processing IRC server 'replies' or 'queries'.
	public void parseFromServer(String lineFromServer) throws IOException {
		myParser parser = new myParser(lineFromServer);
		String command = parser.getCommand();
		if (command.equals("PING")) {
		   parseSendToCommand("PONG :" + parser.getTrailing());
		}
                else if (command.equals("JOIN")) {
		      String channelName = parser.getTrailing();
		      if (channelName.startsWith("#"))
		      {
		         channelName = channelName.substring(1);
		         int indexOfChannel = findTab(tabbedPane, "#" + channelName);
			 if (indexOfChannel == -1) { // Channel Tab doesn't exist
		            ChannelPanel channel = addChannel(tabbedPane, channelName);
		            indexOfChannel = findTab(tabbedPane, "#" + channelName);
		            tabbedPane.setSelectedIndex(indexOfChannel);
			    channel.updateTextArea("*** Now talking in: " + parser.getTrailing());
			    if (tabbedPane.getSelectedIndex() != findTab(tabbedPane, "#" + channelName))
                            	tabbedPane.setBackgroundAt(findTab(tabbedPane, "#" + channelName), Color.red);
			    tabbedPane.revalidate();

		           // channel.updateUserArea(parser.getNick(), "add");
			 }
			 else { // channelName tab exists!
		            ChannelPanel channel = (ChannelPanel)tabbedPane.getComponentAt(indexOfChannel);
			    channel.updateTextArea("---> JOIN: " + parser.getNick() + " (" + parser.getUser() + "@" + 
			                 parser.getHost() + ")");
			    if (tabbedPane.getSelectedIndex() != indexOfChannel)
                            	tabbedPane.setBackgroundAt(indexOfChannel, Color.red);
			    tabbedPane.revalidate();

		            channel.updateUserArea(parser.getNick(), "add");
			 }
		   }
                }
		else if (command.equals("PRIVMSG")) {
		   // handle PRIVMSG
		   String destination = parser.getMiddle();
		   if (destination.startsWith("#")) {
		      // it's a channel!
		      String channelName = destination.substring(1);

// MSG Received....!

		      int indexOfChannel = findTab(tabbedPane, destination);
		      if (indexOfChannel != -1)  { // A connection/tab already exists!
			Component aComponent = tabbedPane.getComponentAt(indexOfChannel);
			if (aComponent instanceof ChannelPanel) {
				String trailing;
				String nick;
				nick = parser.getNick();
				trailing = parser.getTrailing();
				if (trailing.indexOf(1) != -1)  {  // is this a CTCP
					//remove \001 from Beginning and End of CTCP msg
					trailing = trailing.substring(1,trailing.length()-1);
					((ChannelPanel)aComponent).updateTextArea(
						formatNickname("[" + nick + "] ") + trailing);
				}
				String bracketFermeture = "a";
				if (trailing.indexOf("[") != -1) {
					bracketFermeture = String.valueOf(trailing.charAt(trailing.indexOf("[") + 5));
					//System.out.println("bracketFermeture = " + bracketFermeture + " trailing = " + trailing);
				}
				if ((trailing.indexOf("[") != -1) && (bracketFermeture.equals("]")) && (trailing.indexOf("#") == 1 || trailing.indexOf("#") == 0) && (trailing.indexOf("x ") != -1) && (trailing.indexOf("] ") != -1)) {
					String pack = "nullllll";
					String packDescription;
					if (trailing.indexOf("#") < trailing.indexOf(" ")) {
						pack = trailing.substring(trailing.indexOf("#"), trailing.indexOf("#") + 3);
						packDescription = trailing.substring(trailing.indexOf("["), trailing.length());
//						xdccTree.addNode(pack + " From " + nick + " ---> " + packDescription);
						Component xdccComponent = tabbedPane.getComponentAt(1);
						String xdccPackString = nick + " offers " + pack + " ---> " + packDescription;
						((XdccPanel)xdccComponent).updateXdccArea(xdccPackString, "add");
					}
					//else
					//	tabUpdate("Init Window", "Unhandled XDCC channel MSG-> " + trailing);
				}

//set color if its me
				if (nick.equals(nickname)) {
					//System.out.println("Color ReD!");
					//((ChannelPanel)aComponent).textArea.setDisabledTextColor(new Color(255,0,0));
					((ChannelPanel)aComponent).updateTextArea(
						formatNickname("<" + nick + "> ") + trailing);
				}
				else {
					//System.out.println("Color GreeN!");
					//((ChannelPanel)aComponent).textArea.setDisabledTextColor(new Color(0,0,255));
					((ChannelPanel)aComponent).updateTextArea(
						formatNickname("<" + nick + "> ") + trailing);
				}
				if (tabbedPane.getSelectedIndex() != indexOfChannel)
					tabbedPane.setBackgroundAt(indexOfChannel, Color.red);
				tabbedPane.revalidate();
			}
			}
			else { // A connection/tab doesn't exists, so create one!
				ChannelPanel channel = addChannel(tabbedPane, channelName);
				channel.updateTextArea(
					formatNickname("<" + parser.getNick() + "> ") + "> " + parser.getTrailing());
				if (tabbedPane.getSelectedIndex() != findTab(tabbedPane, "#" + channelName))
					tabbedPane.setBackgroundAt(findTab(tabbedPane, "#" + channelName), Color.red);
				tabbedPane.revalidate();
			}


		   }
		   else {
		      // it's from a user

		      int indexOfUser = findTab(tabbedPane, parser.getNick());
		      
		      if (indexOfUser == -1) {	
		      	UserPanel userPanel = addUser(tabbedPane, parser.getNick()); //if tab doesnt exist
			// Add the real username@hostname in title of tabbedPane
			userPanel.setTitleArea(parser.getNick() + "!" + parser.getUser() + "@" + parser.getHost());
		      }

		      indexOfUser = findTab(tabbedPane, parser.getNick());
		      
		      if (indexOfUser != -1) { // A user connection/tab already exists!
		        Component aComponent = tabbedPane.getComponentAt(indexOfUser);
			UserPanel userPanel = (UserPanel)aComponent;

			if (aComponent instanceof UserPanel) {
				String ctcpCommand;
				String trailing;
				String dccPort;
				String dccType;

				StringTokenizer st;
				char firstOne = 1;
				
				trailing = parser.getTrailing();
				if (trailing.indexOf(1) != -1)  { //is this a CTCP
					if (trailing.indexOf(" ") != -1) {
						ctcpCommand = trailing.substring(1,trailing.indexOf(" "));
					}
					else {
						ctcpCommand = trailing.substring(1,trailing.indexOf(1, 2));
					}
					
					if (ctcpCommand.equalsIgnoreCase("DCC")) {
						//trailing = DCC SEND aliases.ini 1096670312 4147 287
						//ctcpCommand = trailing.substring(1,5 + trailing.indexOf(" "));
						dccType = trailing.substring(5, trailing.indexOf(" ", 5));
						if (dccType.equals("SEND")) {
							ctcpCommand = ctcpCommand + " " + dccType;
							numDcc++;
							st = new StringTokenizer(trailing.substring(trailing.indexOf(" ") + 6), " ");
							xdccInfos[numDcc][2] = st.nextToken(); // Filename
							xdccInfos[numDcc][1] = st.nextToken(); // Address
							xdccInfos[numDcc][0] = st.nextToken(); // Port
							xdccInfos[numDcc][3] = trailing.substring(trailing.lastIndexOf(" ") + 1, trailing.length() -1); // File Size
							xdccInfos[numDcc][4] = "0"; // Resume Position

							options = iniLoader.getOptions();
							boolean getFileBool = false;
							if (options.charAt(7) == '1') {
								getFileBool = true;
							}
							else {
								if (JOptionPane.showConfirmDialog(this, " DCC Get " + xdccInfos[numDcc][2] + " ?") == 0) {
									getFileBool = true;
								}
							}
							if (getFileBool) {
								File downloadDir = new File("download");
								if (!downloadDir.isDirectory()) {
									downloadDir.mkdir();
								}
								downloadDir = null;
								File newFile = new File("download/" + xdccInfos[numDcc][2]);
								if (newFile.exists()) {
									//PRIVMSG User1 :DCC RESUME filename port position
									xdccInfos[numDcc][4] = Long.toString(newFile.length());
									newFile = null;
									//parseSendToCommand("PRIVMSG " + parser.getNick() + " :DCC RESUME " + xdccInfos[numDcc][2] + " " + xdccInfos[numDcc][0] + " " + xdccInfos[numDcc][4]);
									System.out.println("File exists: PRIVMSG " + parser.getNick() + " " + firstOne + "DCC RESUME " + xdccInfos[numDcc][2] + " " + xdccInfos[numDcc][0] + " " + xdccInfos[numDcc][4] + firstOne);
									parseSendToCommand("PRIVMSG " + parser.getNick() + " :" + firstOne + "DCC RESUME " + xdccInfos[numDcc][2] + " " + xdccInfos[numDcc][0] + " " + xdccInfos[numDcc][4] + firstOne);
								
								}
								else {
									Component xdccComponent = tabbedPane.getComponentAt(1);
									((XdccPanel)xdccComponent).updateDownloadArea(xdccInfos[numDcc][2] + ":" + xdccInfos[numDcc][3] + " Bytes" + " From: " + parser.getNick(), "add");
									newFile = null;
									System.out.println("File doesnt exists: " + xdccInfos[numDcc][1] + " " + xdccInfos[numDcc][0] + " " + xdccInfos[numDcc][2] + " " + xdccInfos[numDcc][3] + " " + xdccInfos[numDcc][4]);
									new ReadDccFile(Long.parseLong(xdccInfos[numDcc][1]), Integer.parseInt(xdccInfos[numDcc][0]), xdccInfos[numDcc][2], Long.parseLong(xdccInfos[numDcc][3]), Long.parseLong(xdccInfos[numDcc][4])).start();
								}
							}
//							else {
								// is it possible to send a PRIVMSG to tell user we refuse file
//							}
						}
						//System.out.println("dccType = " + dccType);
						if (dccType.equals("ACCEPT")) {
							ctcpCommand = ctcpCommand + " " + dccType + " (RESUME reply) ";

							//PRIVMSG User2 :DCC ACCEPT filename port position
							st = new StringTokenizer(trailing.substring(trailing.indexOf(" ") + 8), " ");
							dccPort = st.nextToken();
							dccPort = st.nextToken();

							for (int i = 0; i < 128; i++) {
								if (dccPort.equals(xdccInfos[i][0])) {	
									System.out.println("ACCEPT RESUME");
									new ReadDccFile(Integer.parseInt(xdccInfos[i][1]), Integer.parseInt(xdccInfos[i][0]), xdccInfos[i][2], Integer.parseInt(xdccInfos[i][3]), Integer.parseInt(xdccInfos[i][4])).start();
								}
							}
						}
						
					}
					else if (ctcpCommand.equalsIgnoreCase("PING")) {
						parseSendToCommand("NOTICE " + parser.getNick() + " :" + trailing);
					}

					else if (ctcpCommand.equalsIgnoreCase("VERSION")) {
						String versionReply = "NOTICE " + parser.getNick() + " :" + firstOne + ctcpCommand + " Using Xdcc IRC v0.3b (Java)" + firstOne;
						parseSendToCommand(versionReply);
						
					}
					
					userPanel.updateTextArea(formatNickname("  CTCP " + ctcpCommand + " received from " + parser.getNick()));
				}
			    
			    	else			   // regular privmsg
			   	 	userPanel.updateTextArea(formatNickname("<" + parser.getNick() + "> ") + trailing);
                         
			    	//update le tout
			    	if (tabbedPane.getSelectedIndex() != indexOfUser)
                            		tabbedPane.setBackgroundAt(indexOfUser, Color.red);
			    	tabbedPane.revalidate();
			 }
			}
		  }
		}

		else if (command.equals("PART")) {
                   String channelName = parser.getParams();
		   int index = channelName.indexOf("#");
		   int index2 = channelName.indexOf(":");
		   if (index2 != -1)  {
		      channelName = channelName.substring(index, index2 - 1);
		   }
		   else  {
		      channelName = channelName.substring(index);
		   }

		   if (channelName.startsWith("#")) {
		      channelName = channelName.substring(1);

		      int indexOfChannel = findTab(tabbedPane, "#" + channelName);
		      if (indexOfChannel != -1) { // Tab doesn't exist. Do nothing
		         Component aComponent = tabbedPane.getComponentAt(indexOfChannel);
			 if (aComponent instanceof ChannelPanel) {
			    ((ChannelPanel)aComponent).updateTextArea("<--- PART: " + parser.getNick());
			    ((ChannelPanel)aComponent).updateUserArea(parser.getNick(), "remove");
			 }

			 // Ok, let's remove the tab if the user who left the channel is you
			 if (parser.getNick().equals(getNickname())) {
			    tabbedPane.removeTabAt(indexOfChannel);
			 }
		      }
		   }

		}
		else if (command.equals("QUIT")) {
		   for (int i = 0; i < tabbedPane.getTabCount(); i++) {
		   	Component aComponent = tabbedPane.getComponentAt(i);
		   	if (aComponent instanceof ChannelPanel) {
		   		if (((ChannelPanel)aComponent).usernameList.contains(parser.getNick())) {
		   			((ChannelPanel)aComponent).updateUserArea(parser.getNick(), "remove");
		   			((ChannelPanel)aComponent).updateTextArea("<--- QUIT: " + parser.getNick() + " (" + parser.getTrailing() + ")");
		   		}
		   	}
		   }
//		   tabUpdate("Init Window", parser.getNick() + " has quit (" + parser.getTrailing() + ")");
		}
		else if (command.equals("NICK")) {
		   // handle NICK --- When a user changes its nickname
		   int index = findTab(tabbedPane, parser.getNick());
		   if (index != -1) {
		      // setting the user tab title to changed nickname
		      tabbedPane.setTitleAt(index, parser.getTrailing());

		      // Let's change the name of the UserPanel alsow
		      UserPanel temp = (UserPanel)tabbedPane.getComponentAt(index);
		      temp.setName(parser.getTrailing());
		   }

		   if (parser.getNick().equalsIgnoreCase(getNickname())) {
		      setNickname(parser.getTrailing());
		   }

		   // When a user changes his/her name, his name in every
		   // UserPanel or ChannelPanel should be changed too.
		   // So, we are doing it now --- here
		   String oldNickname = parser.getNick();
		   String newNickname = parser.getTrailing();

		   changeNickname(oldNickname, newNickname);
		}
		else if (command.equals("NOTICE")) {
		   // handle NOTICE ( arranger: savoir de qui elle vient et la mettre au bon endroit)
		   //NOTICE FROM: Wod_ ---> ping
		   String noticeRcvd = parser.getTrailing();
		   Component xdccComponent = tabbedPane.getComponentAt(1);
		   if (noticeRcvd.indexOf(1) != -1) {
		   	tabUpdate("Init Window", " CTCP REPLY: " + parser.getNick() + " ---> " + parser.getTrailing());
		   }
		   else {
		   	String trailing = parser.getTrailing();
		   	String bracketFermeture = "a";
		   	String nick = parser.getNick();
		   	bracketFermeture = String.valueOf(trailing.charAt(trailing.indexOf("[") + 5));
		   	if (nick != "")
				if ((trailing.indexOf("[") != -1) && (bracketFermeture.equals("]")) && (trailing.indexOf("#") == 1 || trailing.indexOf("#") == 0) && (trailing.indexOf("x ") != -1) && (trailing.indexOf("] ") != -1)) {
					String pack = "nullllll";
					String packDescription = "";
					if (trailing.indexOf("#") < trailing.indexOf(" ")) {
						pack = trailing.substring(trailing.indexOf("#"), trailing.indexOf("#") + 3);
						packDescription = trailing.substring(trailing.indexOf("["), trailing.length());
						String xdccPackString = nick + " offers " + pack + " ---> " + packDescription;
						((XdccPanel)xdccComponent).updateXdccArea(xdccPackString, "add");
					}
					tabUpdate("Init Window", "NOTICE FROM: [" + parser.getNick() + "] ---> " + parser.getTrailing());
				}
				else if ((trailing.indexOf("Sending You Pack") != -1) && (trailing.indexOf("Which Is") != -1) && (trailing.indexOf("Resume Supported") != -1)) {
					((XdccPanel)xdccComponent).updateXdccMsgToSend(parser.getNick(), "remove");
					((XdccPanel)xdccComponent).updateXdccMsgArea("[" + parser.getNick() + "] " + parser.getTrailing());
				}
				else if ((trailing.indexOf("All Slots Full, Main queue of size") != -1) && (trailing.indexOf("is Full, Try Again Later") != -1)) {
					((XdccPanel)xdccComponent).updateXdccMsgArea("[" + parser.getNick() + "] " + parser.getTrailing());
				}
				else if ((trailing.indexOf("All Slots Full, Added you to the main queue in position") != -1) && (trailing.indexOf("To Remove youself at a later time type") != -1)) {
					((XdccPanel)xdccComponent).updateXdccMsgToSend(parser.getNick(), "remove");
					((XdccPanel)xdccComponent).updateXdccMsgArea("[" + parser.getNick() + "] " + parser.getTrailing());
				}
				else if ((trailing.indexOf("You have been queued for") != -1) && (trailing.indexOf("currently in main queue position") != -1)) {
					((XdccPanel)xdccComponent).updateXdccMsgArea("[" + parser.getNick() + "] " + parser.getTrailing());
				}
				else if (trailing.indexOf("Closing Connection:") != -1) {
					// TO DO: add me back to the queue
					((XdccPanel)xdccComponent).updateXdccMsgArea("[" + parser.getNick() + "] " + parser.getTrailing());
				}
				else if (trailing.indexOf("All Slots Full, Denied, You already have") != -1) {
					((XdccPanel)xdccComponent).updateXdccMsgArea("[" + parser.getNick() + "] " + parser.getTrailing());
				}
				else if (trailing.indexOf("You can only have 1 transfer at a time") != -1) {
					((XdccPanel)xdccComponent).updateXdccMsgArea("[" + parser.getNick() + "] " + parser.getTrailing());
				}
				else if (trailing.indexOf("Invalid Pack Number, Try Again") != -1) {
					((XdccPanel)xdccComponent).updateXdccMsgArea("[" + parser.getNick() + "] " + parser.getTrailing());
				}
				else if (trailing.indexOf("XDCC SEND denied, you must be on a known channel to request a pack") != -1) {
					((XdccPanel)xdccComponent).updateXdccMsgArea("[" + parser.getNick() + "] " + parser.getTrailing());
				}
				else if (trailing.indexOf("Transfer Completed (") != -1) {
					((XdccPanel)xdccComponent).updateXdccMsgArea("[" + parser.getNick() + "] " + parser.getTrailing());
				}
				else if (trailing.indexOf("You already requested that pack") != -1) {
					((XdccPanel)xdccComponent).updateXdccMsgArea("[" + parser.getNick() + "] " + parser.getTrailing());
				}
				else if (trailing.indexOf("You have a DCC pending, Set your client to receive the transfer.") != -1) {
					((XdccPanel)xdccComponent).updateXdccMsgArea("[" + parser.getNick() + "] " + parser.getTrailing());
				}
				else if (trailing.indexOf("You can't resume the transfer at a point greater than the size of the file") != -1) {
					((XdccPanel)xdccComponent).updateXdccMsgArea("[" + parser.getNick() + "] " + parser.getTrailing() + " (File probably done already.)");
				}
				else {
		   			tabUpdate("Init Window", "NOTICE FROM: [" + parser.getNick() + "] ---> " + parser.getTrailing());
		   		}
		   	else
		   		tabUpdate("Init Window", parser.getTrailing()); //notice from server..
		   }
		}
		else if (command.equals("KICK")) {
                   // handle KICK
                   String kickedNick;
                   String kickedChannel;
                   String temp;
                   temp = parser.getMiddle();
                   kickedChannel = temp.substring(0, temp.indexOf(" "));
                   kickedNick = temp.substring(temp.indexOf(" ") + 1, temp.length());
		   int indexOfChannel = findTab(tabbedPane, kickedChannel);
		   ChannelPanel channel = (ChannelPanel)tabbedPane.getComponentAt(indexOfChannel);
		   if (!(kickedNick.equals(getNickname())))
	  	   {
	  	   	channel.updateTextArea("<- KICK: " + kickedNick + " by " + parser.getNick() + " (" + parser.getTrailing() + ")" );
			channel.updateUserArea(kickedNick, "remove");
		   }
	  	   else { // You have been kicked...
			tabbedPane.removeTabAt(indexOfChannel);
			tabUpdate("Init Window", "You have been kicked from " + kickedChannel + " by " + parser.getNick() + " because " + parser.getTrailing());
		   }
		}
		else if (command.equals("001") ||  // RPL_WELCOME
		         command.equals("002") ||  // RPL_YOURHOST
                         command.equals("003") ||  // RPL_CREATED
                         command.equals("004")) {  // RPL_MYINFO
		   // successful registration
		   tabUpdate("Init Window", parser.getTrailing());
		}
		else if (command.equals("005")) {
		   // RPL_BOUNCE (Server settings)
		   //tabUpdate("Init Window", "005 " + lineFromServer);
		   //tabUpdate("Init Window", "005 " + parser.getTrailing());
		   //System.out.println(parser.getTrailing());
		}
		else if (command.equals("250") ||
			 command.equals("251") ||
                         command.equals("253") ||
                         command.equals("255") ||
                         command.equals("256") ||
                         command.equals("257") ||
                         command.equals("258") ||
                         command.equals("259") ||
                         command.equals("265") ||
                         command.equals("266"))
		{
		   tabUpdate("Init Window", parser.getTrailing());
		}
	
//252 & 254 = num IRCOP and Total Channels
		else if (command.equals("252"))
                {
                	String numThing;
                	numThing = lineFromServer.substring(lineFromServer.indexOf("252") + 5 + nickname.length(), lineFromServer.indexOf(":", 2));
                	tabUpdate("Init Window", numThing + " " + parser.getTrailing());
        	}
		
		else if (command.equals("254")) {
                	String numThing;
                	numThing = lineFromServer.substring(lineFromServer.indexOf("254") + 5 + nickname.length(), lineFromServer.indexOf(":", 2));
                	tabUpdate("Init Window", numThing + " " + parser.getTrailing());
        	}		

//channel full, invite only or need a key
		else if (command.equals("471") ||
			 command.equals("473") ||
			 command.equals("475")) {
                	String channel;
                	channel = lineFromServer.substring(lineFromServer.indexOf("#"), lineFromServer.indexOf(":", 2));
                	tabUpdate("Init Window", parser.getTrailing() + " (" + channel + ")");
        	}	

		else if (command.equals("371") ||
		         command.equals("372") ||
                         command.equals("374") ||
                         command.equals("375") ||
                         command.equals("376")) {
		   //tabUpdate("Init Window", "371-376 " + parser.getTrailing());
		   //tabUpdate("Init Window", "Skipping MOTD!");
		}
		else if (command.equals("311")) { // RPL_WHOISUSER
		   // Ok, let's see how we can process PROCESS
		   StringTokenizer st = new StringTokenizer(parser.getParams(), " \r\n");
		   //StringTokenizer st = new StringTokenizer(parser.getParams(), " ");
		   String whoNick = "",
		          whoUser = "",
			  whoHost = "",
			  whoMode = "",
			  whoRealName = "";

                   for (int i = 0; st.hasMoreTokens();) {
		      String aToken = st.nextToken();
		      if (i == 1) {
		         whoNick = aToken;
		      }
		      else if (i == 2) {
		         whoUser = aToken;
		      }
		      else if (i == 3) {
		         whoHost = aToken;
		      }
		      else if (i == 4) {
		         whoMode = aToken;
		      }
		      else if (i == 5) {
		      	// vrifier!!!!!!!!!!!!!!
		      	String paramsWhois = parser.getParams();
		      	 whoRealName = paramsWhois.substring(paramsWhois.indexOf(aToken) + 1, paramsWhois.length());
		         //whoRealName = aToken.substring(1);
		      }

		      i++;
		   }

		   // Let's show the messages in the Init Window
		   tabUpdate("Init Window", "Whois info for " + whoNick);
		   tabUpdate("Init Window", "  " + whoNick + "!" + whoUser + "@" + whoHost + " " + whoRealName);
		}
		else if (command.equals("312")) {
		   String whoNick = "",
		          whoServer = "",
			  whoServerInfo = "";

		   StringTokenizer st = new StringTokenizer(parser.getParams(), " \r\n");
                   for (int i = 0; st.hasMoreTokens();)
		   {
		      String aToken = st.nextToken();
		      if (i == 1)
		      {
		         whoNick = aToken;
		      }
		      else if (i == 2)
		      {
		         whoServer = aToken;
		      }
		      else if (i == 3)
		      {
		      	// vrifier!!!!!!!!!!!!!! ainsi que whois realname
		      	String paramsWhois = parser.getParams();
		      	whoServerInfo = paramsWhois.substring(paramsWhois.indexOf(aToken) + 1, paramsWhois.length());
		         //whoServerInfo = aToken.substring(aToken.length());
		      }

		      i++;
		   }

		   // Let's update the Init Window
		   tabUpdate("Init Window", "  Server: " + whoServer + " " + whoServerInfo);
		}
		else if (command.equals("313")) {
		   tabUpdate("Init Window", "  Operator: " + lineFromServer);
		}
		else if (command.equals("317")) {
		   String seconds = "",
		          trailing = "";
                   trailing = parser.getTrailing();
		   StringTokenizer st = new StringTokenizer(parser.getParams(), " \r\n");
                   for (int i = 0; st.hasMoreTokens();) {
		      String aToken = st.nextToken();
		      if (i == 2) {
		         seconds = aToken;
			 break;
		      }

		      i++;
		   }
		   tabUpdate("Init Window", " Idle time: " + seconds + " " + trailing);
		}
		else if (command.equals("318")) {
		   tabUpdate("Init Window", parser.getTrailing());
		}
		else if (command.equals("319")) {
		   tabUpdate("Init Window", "  Channels: " + parser.getTrailing());
		}
		else if (command.equals("301")) { // RPL_AWAY
		   StringTokenizer st = new StringTokenizer(parser.getParams(), " \r\n");
		   String awayNickname = "",
		          awayReason = "";
                   for (int i = 0; st.hasMoreTokens();) {
		      String aToken = st.nextToken();
		      if (i == 1) {
		         awayNickname = aToken;
			 break;
		      }

		      i++;
		   }
		   tabUpdate("Init Window", awayNickname + " is away for \"" + parser.getTrailing() + "\"");
		}
		else if (command.equals("305")) { // RPL_UNAWAY
		   System.out.println("305: " + lineFromServer);
		}

		else if (command.equals("333")) { // RPL_UNAWAY
			String topicChannelName = "";
			String topicSetter = "";
			String topicTime = "";
		   	StringTokenizer st = new StringTokenizer(parser.getParams(), " \r\n");
		   	for (int i = 0; st.hasMoreTokens();) {
		      		String aToken = st.nextToken();
		      		if (i == 1) {
		         		topicChannelName = aToken;
		      		}
		      		if (i == 2) {
		      			topicSetter = aToken;
		      		}
		      		if (i == 3) {
		      			topicTime = aToken;
		      			//returns a date in year 1970.......!!!!!!
		      			DateFormat dateTimeInstance = DateFormat.getDateTimeInstance(3,2); //medium time pattern & short date
		      			topicTime = dateTimeInstance.format((new Date(Long.parseLong(topicTime) * 1000)));
		      		}
				      i++;
			}
                   	int indexOfChannel = findTab(tabbedPane, topicChannelName);
		   	if (indexOfChannel != -1) {
		      		Component aComponent = tabbedPane.getComponentAt(indexOfChannel);
		      		if (aComponent instanceof ChannelPanel) {
		         		((ChannelPanel)aComponent).updateTextArea("Topic set by: " + topicSetter + " at " + topicTime);
		      		}
		   	}
			
		}

// used or not ???????
		else if (command.equals("332"))  { // RPL_TOPIC
		   String topicChannelName = "",
		          topicTopic = "";

		   StringTokenizer st = new StringTokenizer(parser.getParams(), " \r\n");
		   for (int i = 0; st.hasMoreTokens();) {
		      String aToken = st.nextToken();
		      if (i == 1) {
		         topicChannelName = aToken;
			 break;
		      }

		      i++;
		   }

                   int indexOfChannel = findTab(tabbedPane, topicChannelName);
		   if (indexOfChannel != -1) {
		      Component aComponent = tabbedPane.getComponentAt(indexOfChannel);
		      if (aComponent instanceof ChannelPanel) {
		         ((ChannelPanel)aComponent).setTitleArea(parser.getTrailing());
		      }
		   }
		}
		else if (command.equals("TOPIC")) {
		   String topicChannelName = "";

                   StringTokenizer st = new StringTokenizer(parser.getParams(), " \r\n");
		   if (st.hasMoreTokens())
		      topicChannelName = st.nextToken();

                   int indexOfChannel = findTab(tabbedPane, topicChannelName);
		   if (indexOfChannel != -1) {
		      Component aComponent = tabbedPane.getComponentAt(indexOfChannel);
		      if (aComponent instanceof ChannelPanel) {
		         ((ChannelPanel)aComponent).setTitleArea(parser.getTrailing());
		         ((ChannelPanel)aComponent).updateTextArea("TOPIC: " + parser.getTrailing() + " (" + parser.getNick() + ")");
		      }
		   }
		}
		else if (command.equals("353")) {
		   String channelName = parser.getMiddle();
		   int index = channelName.lastIndexOf("#");
		   channelName = channelName.substring(index);

                   // Find the tab of channelName
		   int indexOfChannel = findTab(tabbedPane, channelName);

		   // If the channelName tab exists!
		   if (indexOfChannel != -1) {
		      Component aComponent = tabbedPane.getComponentAt(indexOfChannel);
		      if (aComponent instanceof ChannelPanel) {
		         // All the usernames are in trailing!
		         String trailing = parser.getTrailing();

			 // let's split those usernames with StringTokenizer
		         StringTokenizer st = new StringTokenizer(trailing, " \r\n");

			 // How many users are there?
		         int totalTokens = st.countTokens();

		         for (int i = 0; i < totalTokens; i++) {
			    // a username/nickname
			    String tempnickname = st.nextToken();

			    // Add that username to channelPanel's usernameBox
		            ((ChannelPanel)aComponent).updateUserArea(tempnickname, "add");
		         }
		      }
		   }
		   else  {  // channelName tab doesn't exist!
		   }
		}

		else if (command.equals("404")) {
		   tabUpdate("Init Window", "ERROR: Cannot send msg to channel! (" + lineFromServer + ")");
		}

		else if (command.equals("421")) {
		   //regarder pourquoi lineFromServer est null parfois
		   if (lineFromServer.length() > 3)
		   tabUpdate("Init Window", "ERROR: Server can't find command! (" + lineFromServer + ")");
		}
		
		else if (command.equals("442")) {
		   tabUpdate("Init Window", "ERROR: You're not on that channel! (" + lineFromServer + ")");
		}
		
		else if (command.equals("443")) {
		   tabUpdate("Init Window", "ERROR: User is already on that channel! (" + lineFromServer + ")");
		}
		
		else if (command.equals("461")) {
		   tabUpdate("Init Window", "ERROR: Need more params for this command! (" + lineFromServer + ")");
		}

		else if (command.equals("482")) {
		   tabUpdate("Init Window", "ERROR: You must be channel operator for this! (" + lineFromServer + ")");
		}
		
		else if (command.equals("433")) {
		   tabUpdate("Init Window", nickname + " already in use " + parser.getTrailing());

	  	    String newNickname;
		    newNickname = JOptionPane.showInputDialog(" Change current nickname: " + getNickname() + " to: ", nickname);

        	    if (newNickname != null) {
	      	    	    nickname = newNickname;
			    Component aComponent = tabbedPane.getComponentAt(0);
			    ((InitPanel)aComponent).setTitleArea(newNickname + " connected to: " + host + ":" + port);
	        	    parseSendToCommand("NICK " + newNickname);
		    }
		}
		else {
		   if (lineFromServer.indexOf("MODE") != -1) {
		   	String nickCommand;
		   	String modeReceiver;
		   	String modeReceived;
		   	String temp;
		   	String channelsMode;
		   	temp = lineFromServer.substring(1, lineFromServer.indexOf(" "));
		   	nickCommand = temp;
		   	if (temp.indexOf("!") != -1) {
			   	nickCommand = temp.substring(0, temp.indexOf("!"));
			}
			temp = lineFromServer.substring(lineFromServer.indexOf(" ", lineFromServer.indexOf(" ") + 1));
			temp = temp.substring(temp.indexOf(" "));
// User mode
			if (temp.indexOf(":") != -1) {
				modeReceiver = temp.substring(0, temp.indexOf(":") - 1);
				modeReceived = temp.substring(temp.indexOf(":") + 1);
				tabUpdate("Init Window", nickCommand + " sets MODE: " + modeReceived + " " + modeReceiver);
			}
// Channel mode
			else {
				channelsMode = temp.substring(1, temp.indexOf(" ", 1));
				modeReceived = temp.substring(temp.indexOf(" ", 1) + 1, temp.length());
				
				int indexOfChannel = findTab(tabbedPane, channelsMode);
		   		if (indexOfChannel != -1) {
		      			Component aComponent = tabbedPane.getComponentAt(indexOfChannel);
		      			if (aComponent instanceof ChannelPanel) {
		         			((ChannelPanel)aComponent).updateTextArea(nickCommand + " sets MODE: " + modeReceived);
		      			}
				}
//				tabUpdate("Init Window", nickCommand + " sets MODE: " + modeReceiver + " for channel: " + channelsMode);
			}
		   }
		   else if (lineFromServer.indexOf(" 366 ") != -1);
			//System.out.println("END of Channel name list.");
		   else
		   	tabUpdate("Init Window", "Command not found (lineFromServer): " + lineFromServer);
		}
	}

	private int findTab(final JTabbedPane tabbedPane, String title) {

	   for (int i = 0; i < tabbedPane.getTabCount(); i++) {
	      String tabTitle = tabbedPane.getTitleAt(i);

	      // Let's see whether tabbedPane title and title matches!
	      if (tabTitle.equalsIgnoreCase(title)) {
	         return i;
	      }
	   }
           
	   // Not found anything? Return -1
	   return -1;
	}

	private int tabUpdate(String tabTitle, String message) {
	   int indexOfTab = findTab(tabbedPane, tabTitle);
           
	   if (indexOfTab != -1) {
	      Component aComponent = tabbedPane.getComponentAt(indexOfTab);
	      if (aComponent instanceof ChannelPanel) {
	         ((ChannelPanel)aComponent).updateTextArea(message);
	         if (tabbedPane.getSelectedIndex() != indexOfTab)
                 	tabbedPane.setBackgroundAt(indexOfTab, Color.red);
		 tabbedPane.revalidate();
	      }
	      else if (aComponent instanceof UserPanel) {
	         ((UserPanel)aComponent).updateTextArea(message);
	         if (tabbedPane.getSelectedIndex() != indexOfTab)
                 	tabbedPane.setBackgroundAt(indexOfTab, Color.red);
		 tabbedPane.revalidate();
	      }
	      else if (aComponent instanceof InitPanel) {
	         ((InitPanel)aComponent).updateTextArea(message);
	         if (tabbedPane.getSelectedIndex() != indexOfTab)
                 	tabbedPane.setBackgroundAt(indexOfTab, Color.red);
		 tabbedPane.revalidate();
	      }
	   }

	   return indexOfTab;
	}

	public void parseSendToCommand(String lineToServer) {
		toServer.println(lineToServer);
		toServer.flush();
	}

	private JMenuItem addMenuItem(JMenu menu, Action action) {
		JMenuItem item = menu.add(action);
		
		KeyStroke keystroke = (KeyStroke)action.getValue(action.ACCELERATOR_KEY);
		if (keystroke != null)
		   item.setAccelerator(keystroke);
		
		return item;
	}
	
	private JTabbedPane createTabbedPane() {
		JTabbedPane tabbedPane = new JTabbedPane();
	
                // Adding the init window
		tabbedPane.add(new InitPanel(), "Init Window");
		tabbedPane.add(new XdccPanel(), "XDCCS");
		
		tabbedPane.addChangeListener(new ChangeListener() {
				public void stateChanged(ChangeEvent e) {
					setSelectedTab();
				}
			});
		return tabbedPane;
	}
	
			
	private void setSelectedTab() {
		// to return a selected tab to it's original color
		if (tabbedPane.getModel().isSelected()) {
			int index = tabbedPane.getSelectedIndex();
			
			// setting a background color to null makes
			// a tab's background to it's default background color
			tabbedPane.setBackgroundAt(index, null);
			
			tabbedPane.revalidate();
		}
	}
	
		 //if (toServer != null)

	public class DisconnectAction extends AbstractAction {
		DisconnectAction(String name) {
			super(name);
			putValue(Action.SHORT_DESCRIPTION, " Disconnect ");
		}
		DisconnectAction(String name, KeyStroke keystroke) {
			this(name);
			if (keystroke != null) {
				putValue(ACCELERATOR_KEY, keystroke);
			}
		}
		
		public void actionPerformed(ActionEvent e) {
			if (toServer != null) {
				closeAll();
				tabUpdate("Init Window", "Disconnected!");
			}
			else {
				tabUpdate("Init Window", "You aren't connected.");
			}
		}
	}

	public void createJoinChannelsDialog() {
		MakeJoinChannelsDialog makeJoinChannelsDialog = new MakeJoinChannelsDialog(this);
	}

	public class ChannelListAction extends AbstractAction {
		ChannelListAction(String name) {
			super(name);
			putValue(Action.SHORT_DESCRIPTION, " Channels List.. ");
		}
		
		ChannelListAction(String name, KeyStroke keystroke) {
			this(name);
			if (keystroke != null) {
				putValue(ACCELERATOR_KEY, keystroke);
			}
		}
		
		public void actionPerformed(ActionEvent e) {
			createJoinChannelsDialog();
		}
	}

	public class NewUserAction extends AbstractAction {
	//	NewUserAction(String name, ImageIcon newUserIcon) {
		NewUserAction(String name) {
			super(name);
			putValue(Action.SHORT_DESCRIPTION, " Private msg to a nickname ");
		}
		
		NewUserAction(String name, KeyStroke keystroke) {
			this(name);
			if (keystroke != null) {
				putValue(ACCELERATOR_KEY, keystroke);
			}
		}
		
		public void actionPerformed(ActionEvent e) {
			String userName = "";
			
			userName = JOptionPane.showInputDialog(" Input a nickname to talk privately ");
			if (userName != null && !userName.equals("")) {
			   addUser(tabbedPane, userName);
			}
		}
	}

	public class ChangeNickAction extends AbstractAction {
	   ChangeNickAction(String name) {
	      super(name);
	      putValue(Action.SHORT_DESCRIPTION, "Change your current nickname");
	   }

	   ChangeNickAction(String name, KeyStroke keystroke) {
	      this(name);
	      if (keystroke != null) {
	         putValue(ACCELERATOR_KEY, keystroke);
	      }
	   }

	   public void actionPerformed(ActionEvent e)
	   {
	      String newNickname = "";

	      newNickname = JOptionPane.showInputDialog(" Change current nickname: " + getNickname() + " to: ");

              if (newNickname != null && !newNickname.equals("")) {
		 if (toServer != null) {
		    Component aComponent = tabbedPane.getComponentAt(0);
		    ((InitPanel)aComponent).setTitleArea(nickname + " connected to: " + host + ":" + port);
	            parseSendToCommand("NICK " + newNickname);
		 }
	      }
	   }
	}

	public class WhoisAction extends AbstractAction {
	   WhoisAction(String name) {
	      super(name);
	      putValue(Action.SHORT_DESCRIPTION, "Check nickname Info");
	   }

	   WhoisAction(String name, KeyStroke keystroke) {
	      this(name);
	      if (keystroke != null) {
	         putValue(ACCELERATOR_KEY, keystroke);
	      }
	   }

	   public void actionPerformed(ActionEvent e) {
	      String whoisNickname = "";

	      whoisNickname = JOptionPane.showInputDialog(" Check Info of(Input nickname): ");

              if (whoisNickname != null && !whoisNickname.equals("")) {
		 if (toServer != null) {
	            parseSendToCommand("WHOIS " + whoisNickname);
		 }
	      }
	   }
        }
	
	public class AboutAction extends AbstractAction {
	   AboutAction(String name) {
	      super(name);
	      putValue(Action.SHORT_DESCRIPTION, "About...");
	   }

	   AboutAction(String name, KeyStroke keystroke) {
	      this(name);
	      if (keystroke != null) {
	         putValue(ACCELERATOR_KEY, keystroke);
	      }
	   }

	   public void actionPerformed(ActionEvent e) {
	      JOptionPane.showMessageDialog(XdccIrc.this,                       // parent
	                                    "  XDCC IRC 0.3 based on jqIRC \n" + 
					    "  Wod(wod_@hotmail.com) \n\n" +
					    "  Original Author: jchakma@yahoo.com\n" +
					    "  http://www.geocities.com/jchakma/jqIRC/ \n\n",
					    "About XDCC IRC",                    // title
					    JOptionPane.INFORMATION_MESSAGE);
	   }
	}

	private UserPanel addUser(final JTabbedPane tabbedPane, String name) {
	        UserPanel userPanel = new UserPanel(name);
		tabbedPane.add(userPanel, name);
		tabbedPane.revalidate();
		
		return userPanel;
	}	
	
	private ChannelPanel addChannel(final JTabbedPane tabbedPane, String name) {
	        ChannelPanel channel;

	        if (name.startsWith("#")) {
	           channel = new ChannelPanel(name);
		   tabbedPane.add(channel, name);
		}
		else {
	           channel = new ChannelPanel("#" + name);
		   tabbedPane.add(channel, "#" + name);
		}
		tabbedPane.revalidate();
		
		return channel;
	}	
	
	public JTabbedPane closeChannel(final JTabbedPane tabbedPane, String name) {
		int index;
		
		index = tabbedPane.indexOfTab(name);
		
		if (index != -1 && index >= 0) {
			tabbedPane.removeTabAt(index);
		}
		
		tabbedPane.revalidate();
		return tabbedPane;
	}
	
	public class ConnectionAction extends AbstractAction {
		ConnectionAction(String name) {
			super(name);
		}
		
		ConnectionAction(String name, KeyStroke keystroke) {
			this(name);
			if (keystroke != null) {
				putValue(ACCELERATOR_KEY, keystroke);
			}
		}
		
		public void actionPerformed(ActionEvent e) {
			Object source = e.getSource();
		}
	}

	public class MakeOptionsDialog extends JDialog implements ActionListener {

		MakeOptionsDialog(JFrame parent) {
			super(parent, " Options ", true);
			makeDialog();
		}

		Container optionsDialogContentPane = this.getContentPane();

		JPanel ircPanel = new JPanel();
//		JTextArea performTextArea = new JTextArea();
//		JLabel label1 = new JLabel("Nickname1: ");
		JCheckBox performCheckBox = new JCheckBox("On connect perform these commands");
		JCheckBox logMsgCheckBox = new JCheckBox("Log private messages and notices");
		JCheckBox logChanCheckBox = new JCheckBox("Log channels");
		JCheckBox floodCheckBox = new JCheckBox("Enable flood protection");
		JCheckBox stripCheckBox = new JCheckBox("Strip control codes");
		JCheckBox timestampCheckBox = new JCheckBox("Timestamp events");
		
		JButton okButton = new JButton("Ok");
		JButton cancelButton = new JButton("Cancel");
		
		JPanel dccPanel = new JPanel();
		JLabel timeoutLabel = new JLabel("Timeout for DCC (secs) ");
		JTextField timeoutTextField = new JTextField(3);
		JLabel packetSizeLabel = new JLabel("DCC SEND packet size ");
		JTextField packetSizeTextField = new JTextField(5);
		JCheckBox autoAcceptCheckBox = new JCheckBox("Auto-accept DCC sends");
		JCheckBox autoResumeCheckBox = new JCheckBox("Auto-resume if file exists");
		
		private void makeDialog() {
			okButton.addActionListener(this);
			cancelButton.addActionListener(this);
			performCheckBox.setEnabled(false);
			logMsgCheckBox.setEnabled(false);
			logChanCheckBox.setEnabled(false);
			floodCheckBox.setEnabled(false);
			stripCheckBox.setEnabled(false);
			timestampCheckBox.setEnabled(false);
			packetSizeTextField.setEnabled(false);
			timeoutTextField.setEnabled(false);
			ircPanel.setBorder(makeBorder(" IRC Settings "));
			dccPanel.setBorder(makeBorder(" DCC Settings "));
			
			Box box1 = Box.createVerticalBox();
			box1.add(performCheckBox);
			box1.add(logMsgCheckBox);
			box1.add(logChanCheckBox);
			box1.add(floodCheckBox);
			box1.add(stripCheckBox);
			box1.add(timestampCheckBox);

			Box box2 = Box.createHorizontalBox();
			box2.add(timeoutLabel);
			box2.add(timeoutTextField);

			Box box3 = Box.createHorizontalBox();
			box3.add(packetSizeLabel);
			box3.add(packetSizeTextField);

			Box box4 = Box.createVerticalBox();
			box4.add(box2);
			box4.add(box3);
			box4.add(autoAcceptCheckBox);
			box4.add(autoResumeCheckBox);

			Box box5 = Box.createHorizontalBox();
			box5.add(okButton);
			box5.add(cancelButton);

			ircPanel.add(box1);
			dccPanel.add(box4);

			options = iniLoader.getOptions();
			if (options.charAt(6) == '1') {
	   			timestampCheckBox.setSelected(true);
	   		}
			if (options.charAt(7) == '1') {
	   			autoAcceptCheckBox.setSelected(true);
	   		}
	   		if (options.charAt(8) == '1') {
	   			autoResumeCheckBox.setSelected(true);
	   		}
			optionsDialogContentPane.add("North", ircPanel);
			optionsDialogContentPane.add("Center", dccPanel);
			optionsDialogContentPane.add("South", box5);
			this.pack();
			this.setLocationRelativeTo(this);
			this.show();
		}
		
		public void actionPerformed(ActionEvent ae) {
			if (ae.getSource() == okButton) {
				if (timestampCheckBox.isSelected()) {
					iniLoader.setOptions("1", 6, 7);
		    		}
				else {
					iniLoader.setOptions("0", 6, 7);
				}
				if (autoAcceptCheckBox.isSelected()) {
					iniLoader.setOptions("1", 7, 8);
		    		}
				else {
					iniLoader.setOptions("0", 7, 8);
				}
				if (autoResumeCheckBox.isSelected()) {
					iniLoader.setOptions("1", 8, 9);
		    		}
				else {
					iniLoader.setOptions("0", 8, 9);
				}
				this.dispose();
			}
			if (ae.getSource() == cancelButton) {
				this.dispose();
			}
		}
	}

	public class MakeJoinChannelsDialog extends JDialog implements ActionListener {
		//dialog = new JDialog(this, " Channel List ", true);
		
		MakeJoinChannelsDialog(JFrame parent) {
			super(parent, " Channels List ", true);
			makeDialog();
		}
		
		Container channelsListDialogContentPane = this.getContentPane();
		JLabel label1 = new JLabel("Channel: ");
		final JTextField channelTextField = new JTextField("#", 20);
		JButton joinButton = new JButton("Join");
		JButton addButton = new JButton("Add");
		JButton editButton = new JButton("Edit");
		JButton removeButton = new JButton("Remove");
		JButton joinListButton = new JButton("Join");
		JButton okButton = new JButton("Ok");
		JButton cancelButton = new JButton("Cancel");
		final DefaultListModel channelListModel = new DefaultListModel();
		final JList channelList = new JList(channelListModel);
		Dimension listDim = new Dimension(125,300);
		
		private void makeDialog() {
			joinButton.addActionListener(this);
			addButton.addActionListener(this);
			editButton.addActionListener(this);
			removeButton.addActionListener(this);
			joinListButton.addActionListener(this);
			okButton.addActionListener(this);
			cancelButton.addActionListener(this);
			channelList.setMinimumSize(listDim);
			JScrollPane sp1 = new JScrollPane(channelList);
			sp1.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			
			channels = iniLoader.getChannels();

			for (int i = 0; !channels[i].equals(""); i++) {
				channelListModel.addElement(channels[i]);
			}

			Box box1 = Box.createHorizontalBox();
			box1.add(label1);
			box1.add(channelTextField);
			box1.add(joinButton);
		
			Box box2 = Box.createVerticalBox();
			box2.add(box1);
			box2.add(sp1);
		
			Box box3 = Box.createVerticalBox();
			box3.add(addButton);
			box3.add(editButton);
			box3.add(removeButton);
			box3.add(joinListButton);
			box3.add(okButton);
			box3.add(cancelButton);
		
			Box box4 = Box.createHorizontalBox();
			box4.add(box2);
			box4.add(box3);
		
			channelsListDialogContentPane.add(box4);
			this.pack();
			this.setLocationRelativeTo(this);
			this.show();
		}

		public void actionPerformed(ActionEvent ae) {
			if (ae.getSource() == joinButton) {
	        		if (channelTextField.getText().startsWith("#") && channelTextField.getText() != "") {
					parseSendToCommand("JOIN " + channelTextField.getText());
				}
				else if (channelTextField.getText() != "") {
					parseSendToCommand("JOIN #" + channelTextField.getText());
				}
				channelTextField.setText("#");
				saveChannels();
				this.dispose();
			}
			else if (ae.getSource() == addButton) {
		        	if (channelTextField.getText() != "") {
					if (channelTextField.getText().startsWith("#")) {
						channelListModel.addElement(channelTextField.getText());
					}
					else {
						channelListModel.addElement("#" + channelTextField.getText());
					}
				}
				channelTextField.setText("#");
			}
			else if (ae.getSource() == editButton) {
				String chanToEdit = "";
				if (channelList.getSelectedIndex() != -1) {
					chanToEdit = (String)channelListModel.getElementAt(channelList.getSelectedIndex());
					chanToEdit = JOptionPane.showInputDialog(" New Channel : ", chanToEdit);
					if (chanToEdit != "") {
						//channelListModel.removeElementAt(channelList.getSelectedIndex());
						int chanIndex = channelList.getSelectedIndex();
						if (chanToEdit.startsWith("#")) {
							channelListModel.setElementAt(chanToEdit, chanIndex);
						}
						else {
							channelListModel.setElementAt("#" + chanToEdit, chanIndex);
						}
					}
				}
			}
			else if (ae.getSource() == removeButton) {
				if (channelList.getSelectedIndex() != -1) {
					channelListModel.removeElementAt(channelList.getSelectedIndex());
				}
			}
			else if (ae.getSource() == joinListButton) {
				if (channelList.getSelectedIndex() != -1) {
					parseSendToCommand("JOIN " + channelList.getSelectedValue());
				}
				saveChannels();
				this.dispose();
			}
			else if (ae.getSource() == okButton) {
				saveChannels();
				this.dispose();
			}
			else if (ae.getSource() == cancelButton) {
				this.dispose();
			}
		}
		public void saveChannels() {
			iniLoader.setChannels(channelListModel.toArray());
		}
	}


	public class XdccPanel extends JPanel implements ActionListener { //, ListSelectionListener
		final SortedListModel xdccListModel = new SortedListModel();
		final SortedListModel downloadListModel = new SortedListModel();
		final JList xdccList = new JList(xdccListModel);
		JList downloadList = new JList(downloadListModel);
		JTextArea xdccMsgTextArea = new JTextArea();
		JScrollPane sp3;
		String name;
		Vector xdccMsgToSend = new Vector();
		Timer xdccMsgTimer = new Timer(120000,this);
		JPopupMenu popup;
		JMenuItem miGet;
		JMenuItem miRemove;
		JMenuItem miPrint;
		JButton openDirButton = new JButton("Open Download Directory");

/*
 * NOTICE FROM: DAY-DCC50 ---> *** All Slots Full, Added you to the main queue in position 14. To Remove youself at a later time type "/msg DAY-DCC50 xdcc remove".
 * NOTICE FROM: DAY-DCC50 ---> You have been queued for 0 hr 2 min, currently in main queue position 13 of 14.  Estimated remaining time is 12 hr 38 min or more.  To remove yourself type "/msg DAY-DCC50 xdcc remove".
 */
		public XdccPanel() {
			makePanel();
		}
		
		private void makePanel() {
			xdccMsgTimer.start();
			setLayout(new BorderLayout());
        	        Toolkit theKit = java.awt.Toolkit.getDefaultToolkit();
			Dimension dm = theKit.getScreenSize();
			
        		xdccList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			
			JScrollPane sp1 = new JScrollPane(xdccList);
			sp1.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
                        
			JScrollPane sp2 = new JScrollPane(downloadList);
			sp1.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
                        
			xdccMsgTextArea.setLineWrap(true);
			sp3 = new JScrollPane(xdccMsgTextArea);
			sp3.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
                        sp3.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			Dimension xdccMsgDim = new Dimension(800,75);
			//sp3.setPreferredSize(xdccMsgDim);
			//xdccMsgTextArea.setPreferredSize(xdccMsgDim);
			xdccMsgTextArea.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
			Box northBox = Box.createHorizontalBox();
			openDirButton.addActionListener(this);
			northBox.add(openDirButton);
			northBox.add(sp3);

			northBox.setPreferredSize(xdccMsgDim);
			JSplitPane splitPaneH = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, sp1, sp2);
                        splitPaneH.setOneTouchExpandable(true);
                        splitPaneH.setDividerLocation(dm.width - 400);
			JSplitPane splitPaneV = new JSplitPane(JSplitPane.VERTICAL_SPLIT, northBox, splitPaneH);
                        splitPaneV.setOneTouchExpandable(true);
                        
			popup = new JPopupMenu();
    			miGet = new JMenuItem("Get it");
    			miRemove = new JMenuItem("Remove from queue");
    			miPrint = new JMenuItem("Print list into a file");
    			miGet.addActionListener(this);
    			miGet.setActionCommand("get");
    			miRemove.addActionListener(this);
    			miRemove.setActionCommand("remove");    			
    			miPrint.addActionListener(this);
    			miPrint.setActionCommand("print");
    			popup.add(miGet);
    			popup.add(miRemove);
    			popup.add(miPrint);
    			popup.setOpaque(true);
			popup.setLightWeightPopupEnabled(true);
			
			add(splitPaneV, BorderLayout.CENTER);
			//add(northBox, BorderLayout.NORTH);
			
    			xdccList.addMouseListener (
        		new MouseAdapter () {
	           		public void mouseReleased( MouseEvent e ) {
              				if ( e.isPopupTrigger()) {
                  				popup.show( (JComponent)e.getSource(), e.getX(), e.getY() );
	                  		}
        	      		}
           		});
		}

		public void actionPerformed(ActionEvent ae) {
			
			if (ae.getSource() == xdccMsgTimer) {
				for (int i = 0; i < xdccMsgToSend.size(); i++) {
					System.out.println(xdccMsgToSend.elementAt(i));
					parseSendToCommand((String)xdccMsgToSend.elementAt(i));
				}
			}
			else if (ae.getSource() == openDirButton) {
				//Fix this for other OS's
				String osName = System.getProperty("os.name");
				if (osName.indexOf("Windows") != -1) {
					try {
						Process proc = Runtime.getRuntime().exec("explorer.exe " + System.getProperty("user.dir") + "\\download\\");
					}
					catch (IOException e) {
						}
				}
				else {
					System.out.println("Sorry, not yet implemented for other OS's than windows");
				}
			}
			else if (ae.getActionCommand().equals("get")) {
 				String temp = "";
 				String pack = "";
 				String nick = "";

 				temp = String.valueOf(xdccList.getSelectedValue());
 				// nick + " offers " + pack + " ---> " + packDescription;
     				pack = temp.substring(temp.indexOf("offers") + 7, temp.indexOf("--->") - 1);
      				nick =  temp.substring(0, temp.indexOf("offers") - 1);
      				// Timer  ajouter..
      				String thisMsgToSend = "PRIVMSG " + nick + " :XDCC SEND " + pack;
      				parseSendToCommand(thisMsgToSend);
				updateXdccMsgToSend(thisMsgToSend, "add");
      			}
      			
      			else if (ae.getActionCommand().equals("remove")) {
      				String temp = "";
      				String nick = "";
      				temp = String.valueOf(xdccList.getSelectedValue());
      				nick =  temp.substring(0, temp.indexOf("offers") - 1);
      				updateXdccMsgToSend(nick, "remove");
      				parseSendToCommand("PRIVMSG " + nick + " :XDCC REMOVE");
      			}
      			
      			else if (ae.getActionCommand().equals("print")) {
				SimpleDateFormat formatter = new SimpleDateFormat("MMdd");
				String monthDay = formatter.format(new Date());
				try {
					FileOutputStream fos = new FileOutputStream("Xdcc-list-" + monthDay + ".txt");
					PrintStream ps = new PrintStream( fos );

					ps.println("XDCC list created with XdccIrc available at http://www.geocities.com/ironned/");
					ps.println("	You can mail me for comment/suggestions at wod_@hotmail.com");
					ps.println();
					for (int i = 0; i < xdccListModel.getSize(); i++) {
						ps.println(xdccListModel.getElementAt(i).toString());
						//tabUpdate("Init Window", xdccListModel.getElementAt(i).toString());
					}
					try {
						fos.close();
						ps.close();
					}
					catch (IOException e) {
						System.out.println("Couldn't close file. (IOException)");
					}
				}
				catch (FileNotFoundException e) {
					System.out.println("Couldn't create file. (FileNotFoundException)");
				}
			}
		} 
		
		public void updateXdccArea(String xdccPack, String command) {
		        if (command.equals("add")) {
		        	//add Last updated: time+date as jlist tooltip to prevent 2 packs being displayed twice..
/*		           SimpleDateFormat formatter = new SimpleDateFormat("h:mm a");
			   String hourMinute = formatter.format(new Date());
			   for (int i = 0; i < xdccListModel.getSize(); i++) {
			   	if (xdccListModel.getElementAt(i).contains(xdccPack)) {
			   		xdccListModel.removeElementAt(i);
			   		break;
			   	}
			   }*/
			   //xdccListModel.add(xdccPack + "Last updated: " + hourMinute);
			   xdccListModel.add(xdccPack);
			}

			else if (command.equals("remove")) {
			   xdccListModel.removeElement(xdccPack);
			}
		}
		
		public void updateDownloadArea(String downloadingFile, String command) {
			if (command.equals("add")) {
				downloadListModel.add(downloadingFile);
			}

			else if (command.equals("remove")) {
				downloadListModel.removeElement(downloadingFile);
			}
		}
		
		public void updateXdccMsgArea(String line) {
			xdccMsgTextArea.append(line + "\n\r");
		}
		
		public void updateXdccMsgToSend(String line, String command) {
			if (command.equals("add")) {
      				if (!(xdccMsgToSend.contains((Object)line))) {
      					xdccMsgToSend.add(line);
      				}
			}
			else if (command.equals("remove")) {
				for (int i = 0; i < xdccMsgToSend.size(); i++) {				
					if (xdccMsgToSend.elementAt(i).toString().indexOf(line) != -1) {
						xdccMsgToSend.remove(i);
					}
				}
			}
		}
		
		public int getSizeDownloadArea() {
			return downloadListModel.getSize();
		}
		public String getElementAtDownloadArea(int index) {
			return (String)downloadListModel.getElementAt(index);
		}
	}

	public class InitPanel extends JPanel implements ActionListener, KeyListener {
		Vector typedString = new Vector();
		int index1 = 0;
		int index2 = 0;
		final String name = "Init Window";
		final JTextArea textArea = new JTextArea();
		final JTextField textField = new JTextField();
		JTextField titleArea;
		
		public InitPanel() {
			makePanel();
		}
		
		private void makePanel() {
			setLayout(new BorderLayout());
			
                        textArea.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
                        textArea.setLineWrap(true);
                        textArea.setWrapStyleWord(true);
			textField.addActionListener(this);
			textField.addKeyListener(this);
			
                        JScrollPane sp1 = new JScrollPane(textArea);
			
			sp1.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);

                        add(sp1, BorderLayout.CENTER);
                        add(textField, BorderLayout.SOUTH);
			add(makeNorth(), BorderLayout.NORTH);
		}
		
		private Box makeNorth() {
			Box northBox = Box.createHorizontalBox();
			titleArea  = new JTextField("Not connected yet");
			northBox.add(titleArea);
			return northBox;
		}

		public void keyTyped(KeyEvent e) {
		}

		public void keyPressed(KeyEvent e) {
			String currentText;
			if ( e.getKeyCode() == 38 && index2 != 0) { // VK_UP
				index2--;
				currentText = (String)typedString.get(index2);
				textField.setText(currentText);
			}
			else if ( (e.getKeyCode() == 40) && (index2 < typedString.size()) ) { // VK_DOWN
				if (index2 + 1 < typedString.size()) {
					index2++;
					currentText = (String)typedString.get(index2);
					textField.setText(currentText);
				}
				else {
					index2++;
					textField.setText("");
				}
			}
		}

		public void keyReleased(KeyEvent e) {
		}
		
		public void actionPerformed(ActionEvent e) {
			Object source = e.getSource();
			
			// let's take care of textField
			if (source == textField) {
				String message = textField.getText();
				typedString.add(message);
				if (index2 != index1 ) {
					typedString.removeElementAt(index2);
				}
				index1 = typedString.size();
				index2 = index1;
				

                                if (message.startsWith("/")) {
				   analyzeCommand(message);
				   textField.setText("");
				}
			        else {
				   // update textArea
				   textArea.append("You're not on a channel, try: /quote TEXT if you want to send to send text directly to server." + "\n");
				   textField.setText("");
				}
			}
		}
		
		public void resetTextField() {
			textField.setText("");
		}
		
		public void setTitleArea(String message) {
			titleArea.setText(message);
		}
		
		public void updateTextArea(String message) {
		        int oldCaretPosition = textArea.getCaretPosition();
			textArea.append(message + "\n");

			int newCaretPosition = textArea.getCaretPosition();
			if (newCaretPosition == oldCaretPosition) {
			   textArea.setCaretPosition(oldCaretPosition + (message + "\n").length());
			}
		}
	}
	

	private void analyzeCommand(String message) {
	   CommandInterpreter cmdI = new CommandInterpreter(message);

	   if (cmdI.getCommand().equals("QUOTE")) {
	      parseSendToCommand(cmdI.getParam1()  + " " +
				 cmdI.getMessage());
	   }
	   else if (cmdI.getCommand().equals("JOIN")) {
	      parseSendToCommand(cmdI.getCommand() + " " + 
	                         cmdI.getParam1()  + " " +
				 cmdI.getMessage());
	   }
	   else if (cmdI.getCommand().equals("PART") || cmdI.getCommand().equals("LEAVE")) {
	      parseSendToCommand("PART " +
	                         cmdI.getParam1() + " :" +
				 cmdI.getMessage());
	   }
	   else if (cmdI.getCommand().equals("QUIT")) {
	      parseSendToCommand("QUIT :" +
	                         cmdI.getParam1() + " " +
				 cmdI.getMessage());
	   }
	   else if (cmdI.getCommand().equals("WHOIS")) {
	      parseSendToCommand("WHOIS " +
	                         cmdI.getParam1() + " " +
				 cmdI.getMessage());
	   }
	   else if (cmdI.getCommand().equals("MSG")) {
	      parseSendToCommand("PRIVMSG " +
	                         cmdI.getParam1() + " :" +
				 cmdI.getMessage());
	   }
	   else if (cmdI.getCommand().equals("CTCP")) {
	   	char firstChar = 1;
	      parseSendToCommand("PRIVMSG " +
	                         cmdI.getParam1() + " :" + firstChar + cmdI.getMessage() + firstChar);
	   }
	   else if (cmdI.getCommand().equals("NICK")) {
	      parseSendToCommand("NICK " + cmdI.getParam1());
	   }
	   else if (cmdI.getCommand().equals("TOPIC")) {
              if (cmdI.getMessage().equals("")) {
	         parseSendToCommand(cmdI.getCommand() + " " +
	                            cmdI.getParam1() + " :");
	      }
	      else {
	         System.out.println("Sending a message: " + cmdI.getCommand() + " " + 
		                     cmdI.getParam1() + " :" + cmdI.getMessage());
	         parseSendToCommand(cmdI.getCommand() + " " +
	                            cmdI.getParam1() + " :" +
				    cmdI.getMessage());
	      }
	   }
	   else {
	      parseSendToCommand(cmdI.getCommand() + " :" +
	                         cmdI.getParam1()  + " " +
				 cmdI.getMessage());
	   }
	}

	public class ChannelPanel extends JPanel implements ActionListener, KeyListener { //, ListSelectionListener
		Vector typedString = new Vector();
		int index1 = 0;
		int index2 = 0;
		final String name;
		//////final SortedListModel usernameList = new SortedListModel();
		SortedListModel usernameList = new SortedListModel();
		JList userList = new JList(usernameList);
		JTextArea textArea = new JTextArea();
		JTextField textField = new JTextField();
		
	        JTextField titleArea  = new JTextField();

		JButton closeButton = new JButton("X");

		JPopupMenu popup;
		JMenuItem miWhois;
		JMenuItem miXdccList;
		JMenuItem miQuery;
		JMenuItem miNotice;

		public ChannelPanel(String name) {
			this.name = name;
			makePanel();
		}
		
		private void makePanel() {
			setLayout(new BorderLayout());

                        textArea.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
                        textArea.setLineWrap(true);
                        textArea.setWrapStyleWord(true);
                        //textArea.setEditable(false);
			textField.addActionListener(this);
			textField.addKeyListener(this);

        		userList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			
                        JScrollPane sp1 = new JScrollPane(textArea);
                        JScrollPane sp2 = new JScrollPane(userList);
			
			sp1.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			sp2.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			
                        JSplitPane splitPane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, sp1, sp2);
                        splitPane.setOneTouchExpandable(true);

                	Toolkit theKit = java.awt.Toolkit.getDefaultToolkit();
			Dimension dm = theKit.getScreenSize();
                        splitPane.setDividerLocation(dm.width - 140);
                        
                        popup = new JPopupMenu();
    			miWhois = new JMenuItem("Whois");
    			miXdccList = new JMenuItem("Xdcc List");
    			miQuery = new JMenuItem("Query");
    			miNotice = new JMenuItem("Notice..");
    			miWhois.addActionListener(this);
    			miWhois.setActionCommand("whois");
    			miXdccList.addActionListener(this);
    			miXdccList.setActionCommand("xdcclist");
    			miQuery.addActionListener(this);
    			miQuery.setActionCommand("query");
    			miNotice.addActionListener(this);
    			miNotice.setActionCommand("notice");
    			popup.add(miWhois);
    			popup.add(miXdccList);
    			popup.add(miQuery);
    			popup.add(miNotice);
    			popup.setOpaque(true);
			popup.setLightWeightPopupEnabled(true);
                        
                        
                        add(splitPane, BorderLayout.CENTER);
                        add(textField, BorderLayout.SOUTH);
			add(makeNorth(), BorderLayout.NORTH);
		
			userList.addMouseListener (
        		new MouseAdapter () {
	           		public void mouseReleased( MouseEvent e ) {
              				if ( e.isPopupTrigger()) {
                  				popup.show( (JComponent)e.getSource(), e.getX(), e.getY() );
	                  		}
        	      		}
           		}
        		);
		}
		
		private Box makeNorth() {
			Box northBox = Box.createHorizontalBox();
			closeButton.addActionListener(this);
			northBox.add(closeButton);
			northBox.add(titleArea);
			return northBox;
		}
		

		public void keyTyped(KeyEvent e) {
		}

		public void keyPressed(KeyEvent e) {
			String currentText;
			if ( e.getKeyCode() == 38 && index2 != 0) { // VK_UP
				index2--;
				currentText = (String)typedString.get(index2);
				textField.setText(currentText);
			}
			else if ( (e.getKeyCode() == 40) && (index2 < typedString.size()) ) { // VK_DOWN
				if (index2 + 1 < typedString.size()) {
					index2++;
					currentText = (String)typedString.get(index2);
					textField.setText(currentText);
				}
				else {
					index2++;
					textField.setText("");
				}
			}
		}

		public void keyReleased(KeyEvent e) {
		}

		public void actionPerformed(ActionEvent e) {
			Object source = e.getSource();
			String actionCommand = e.getActionCommand();

			// let's take care of textField
			if (source == textField) {
				String message = textField.getText();
				typedString.add(message);
				if (index2 != index1 ) {
					typedString.removeElementAt(index2);
				}
				index1 = typedString.size();
				index2 = index1;
				// let's send to server
				if (message.startsWith("/")) {
				   analyzeCommand(message);
				   textField.setText("");
				}
				else {
				   // A private message to channel!
				   parseSendToCommand("PRIVMSG " + name + " :" + message);

				   // let's update textArea
				   // textArea.append(textField.getText() + "\n");
				   updateTextArea(formatNickname("<" + getNickname() + "> ") + 
				                  textField.getText());
				   resetTextField();
				}
			}
			else if (source == closeButton) {
				closeChannel(tabbedPane, name);

				// Let's send a sensible message
				parseSendToCommand("PART " + name);
			}
			
			else if (source == miWhois || source == miXdccList || source == miNotice || source == miQuery) {
				// placer dans un IF si c est une commande du popup
				String nickSelected = userList.getSelectedValue().toString();
				// corriger, ca n ote pas le @ ou le +
			
				char userStatus = nickSelected.toCharArray()[0];
				if (userStatus == '@' || userStatus == '+') {
					nickSelected = nickSelected.substring(1);
				}
				
				if (actionCommand.equals("whois")) {
					parseSendToCommand("WHOIS " + nickSelected);
      				}
      				
      				if (actionCommand.equals("query")) {
		      			UserPanel userPanel = addUser(tabbedPane, nickSelected);
					// Add the real username@hostname in title of tabbedPane
					userPanel.setTitleArea(nickSelected);
				}
      				if (actionCommand.equals("xdcclist")) {
					parseSendToCommand("PRIVMSG " + nickSelected + " :XDCC LIST");
				}
      				if (actionCommand.equals("notice")) {
					String noticeToSend;
					noticeToSend = JOptionPane.showInputDialog(" Notice to send to " + nickSelected + ": ");
					if (noticeToSend != null) {
						parseSendToCommand("NOTICE " + nickSelected + " :" + noticeToSend);
					}
				}
			}
		}
		
		public void resetTextField() {
			textField.setText("");
		}

		public void setTitleArea(String title) { // Actually, it's user@host
		   titleArea.setText("");
		   titleArea.setText(title);
		}
		
		public void updateTextArea(String message) {
		        int oldCaretPosition = textArea.getCaretPosition();
			textArea.append(message + "\n");

			int newCaretPosition = textArea.getCaretPosition();
			if (newCaretPosition == oldCaretPosition) {
			   textArea.setCaretPosition(oldCaretPosition + (message + "\n").length());
			}
		}

		public void updateUserArea(String username, String command) {
		        if (command.equals("add")) {
		//	   System.out.println("UserName to add -> " + username);
			   usernameList.add(username);
			}

			else if (command.equals("remove")) {
		//	   System.out.println("UserName to remove -> " + username);
			   usernameList.removeElement(username);
			}
		}
	}

	public class UserPanel extends JPanel implements ActionListener {
		String name;
		final JTextArea textArea = new JTextArea();
		final JTextField textField = new JTextField();
		JTextField titleArea  = new JTextField("Title goes over here");
		
		JButton closeButton = new JButton("X");
		
		public UserPanel(String name) {
			this.name = name;
			
			makePanel();
		}

		public void setName(String name) {
		   this.name = name;
		}

		public void setTitleArea(String title) { // Actually, it's user@host
		   titleArea.setText("");
		   titleArea.setText(title);
		}
		
		private void makePanel() {
			setLayout(new BorderLayout());
			
			// let's add actionListener
                        textArea.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
                        textArea.setLineWrap(true);
                        textArea.setWrapStyleWord(true);
			textField.addActionListener(this);
			
                        JScrollPane sp1 = new JScrollPane(textArea);
			
			sp1.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);

           		add(sp1, BorderLayout.CENTER);
                        add(textField, BorderLayout.SOUTH);
			add(makeNorth(), BorderLayout.NORTH);
		}
		
		private Box makeNorth() {
			Box northBox = Box.createHorizontalBox();
			closeButton.addActionListener(this);
			northBox.add(closeButton);
			northBox.add(titleArea);
			return northBox;
		}
		
		public void actionPerformed(ActionEvent e) {
			Object source = e.getSource();

			if (source == textField) {
				String message = textField.getText();

				if (message.startsWith("/")) {
				   analyzeCommand(message);
				   textField.setText("");
				}
				else {
				   // A normal private message to send to the user
				   parseSendToCommand("PRIVMSG " + name + " :" + message);

				   // let's update textArea
				   updateTextArea(formatNickname("<" + getNickname() + "> ") + 
				                  textField.getText());
				   resetTextField();
				}
			}
			else if (source == closeButton) {
				closeChannel(tabbedPane, name);
			}
		}
		
		public void resetTextField() {
			textField.setText("");
		}
		
		public void updateTextArea(String message) {
		        int oldCaretPosition = textArea.getCaretPosition();
			textArea.append(message + "\n");

			int newCaretPosition = textArea.getCaretPosition();
			if (newCaretPosition == oldCaretPosition) {
			   textArea.setCaretPosition(oldCaretPosition + (message + "\n").length());
			}
		}
	}

	public static void main(String[] args) {
		String host = "localhost";
		int port = 6667;
	
		if (args.length == 2) {
			host = args[0];
			try {
				port = Integer.parseInt(args[1]);
			}
			catch(NumberFormatException e) {
				System.out.println("Usage: java XdccIrc server port");
				System.out.println("Port isn't an integer");
				System.out.println("using default port: " + port);
			}
		}
	XdccIrc theApp = new XdccIrc(host, port);
	}
}
